import com.cycling74.max.Atom;
import com.cycling74.max.DataTypes;
import com.cycling74.max.MaxObject;


public class smooth_fonc  extends MaxObject {
	smooth_fonc (Atom[] a) {
		declareInlets(new int[]{DataTypes.ALL});
		declareOutlets(new int[]{DataTypes.ALL,DataTypes.ALL,DataTypes.ALL,DataTypes.ALL,DataTypes.ALL});
		createInfoOutlet(false);	}

	// little patch by Alexandre Flet (alexf1975 at yahoo.fr)
	
	int size = 1000 ; 
	  
	float [] mode  = new float [2] ; 
	float [] slopeslimit  = new float [2] ;
	
	float [] multi  = new float [10];  // multislider in
	float [] multo  = new float [size];  // multislider out
	
	
	public void init() {
		mode [0] = 0f ;
		mode [1] = 1f ;
		slopeslimit [0] = 0f ;
		slopeslimit [1] = 0f ;
		outlet(0, "init smooth_fonc class." ) ;
	}
	public void mode(float [] data) {	mode = data ; 
	multi[0] = mode [0] ; multi[multi.length-1] = mode [1] ; calc() ; }
	
	public void slopeslimit(float [] data) { slopeslimit = data ; calc() ; }
	
	public void size(int value) {	
		size = value ; float [] m = new float [size]; multo = m ;
		; calc() ; }
	
	public void list(float[] values) {
		float [] m  = new float [values.length+2];
		for (int i=1 ; i<m.length-1 ; i++) {
			m[i] = values[i-1] ;
		}
		m[0] = mode [0] ;
		m[m.length-1] = mode [1] ;
		multi = m ; 
		calc() ;
	}
	
	public void calc() {
		
		int sizei = multi.length ; 
		
		float [] pp = new float [sizei] ;  // slopes means for each slider
		pp[0] = slopeslimit [0] ; // first slope : normaly 0
		pp[sizei-1] = slopeslimit [1] ; //  last slope : normaly 0
		
		for (int i=1 ; i<sizei-1 ; i++) {
			pp[i] = (multi[i+1]-multi[i-1]) / 2  ; //mean of slopes (i+1)-(i) and (i)-(i-1) 
		}
		//pp[1] = ( multi[1] - mode [0] ) / 2  ;
		//pp[sizei-2] = ( mode [1] - multi[sizei-2-1-1]) / 2  ;
		//outlet(0, pp) ;
		float [] multol1  = new float [size];
		float [] multol2  = new float [size];
		float [] multoc1  = new float [size];
		float [] multoc2  = new float [size];
		
		float delta, deltam, ii , p , brut , line1, line2 , curve1 , curve2 , curve3 ;
		for (int i=0 ; i<size ; i++) {
			ii= ((float)i) / ((float)size) * ((float)sizei-1) ;
			if ((int)ii<sizei-1) {
				//outlet(0, ii) ;
				delta =  ii - (int)ii;
				//outlet(0, delta) ;
				//deltam = delta ;
				if (delta<0.5){
					deltam = 0.5f - (float)Math.cos(delta*3.14159265)/2  ;
					//deltam =  (delta*2)*(delta*2)/2;
				}else{
					deltam = 0.5f - (float)Math.cos(delta*3.14159265)/2  ;
					//deltam =  1-(((1-delta)*2)*((1-delta)*2)/2);
				}
					
				p = multi[(int)ii+1]-multi[(int)ii] ;  // slope ((int)ii+1)-((int)ii)
				
				brut = delta*p + multi[(int)ii] ;  // simple interpolation
				line1 = delta*pp[(int)ii] + multi[(int)ii] ;
				line2 = (delta-1)*pp[(int)ii+1] + multi[(int)ii+1] ;
				curve1 = (brut*(1-deltam) + line2*(deltam))  / 2   ; 
				curve2 = (line1*(1-deltam) + brut*(deltam))  / 2 ;
				curve3 = (line1*(1-deltam) + line2*(deltam))  / 2 ;
				multol1[i] = line1 ;
				multol2[i] = line2 ;
				multoc1[i] = curve1 + curve2 ;
				//multoc2[i] = curve2*2 ;
				
				multo[i] = curve3 * 2 ;  //curve1 + curve2 ;
				//multo[i] = brut + ((curve1-brut) + (curve2-brut) )/2    ;
			} else {
				multo[i] = mode [1]      ;
			}
		}
		
		outlet(0, multo) ;
		
		outlet(1, multol1) ;
		outlet(2, multol2) ;
		outlet(3, multoc1) ;
		outlet(4, multoc2) ;
	}
	
	
	
}	


